package com.miya.fastcashier.dao

import androidx.room.*
import com.miya.fastcashier.beans.ViewPayOrderData


@Dao
interface PayDataDao {

    @Query("SELECT COUNT(*) FROM pay_data")
    fun getSize(): Int

    @Query("SELECT * FROM pay_data")
    fun getAll(): MutableList<ViewPayOrderData>

    @Query("SELECT * FROM pay_data LIMIT 20")
    fun getOnePage(): MutableList<ViewPayOrderData>

    @Query("SELECT ceil(COUNT(*))/10")
    fun getPageNum(): Int

    @Insert
    fun insertAll(list: MutableList<ViewPayOrderData>)

    @Insert
    fun insertOne(data: ViewPayOrderData)

    @Update
    fun updateOne(data: ViewPayOrderData)

    @Delete
    fun delete(user: ViewPayOrderData)
}